]> pd.if.org Git - zpackage/blobdiff - zpm-install
change chown to lchown
[zpackage] / zpm-install
index 8123b9ba4c90967fa99d1c0d124ef6f43e371873..64b064bf7170d90e4b85f9e12b53374f41a82946 100755 (executable)
 #!/bin/sh
 
-package=${1:-$ZPMPACKAGE}
-shift
-pkgver=${ZPMPACKAGEVER:-1.0}
-pkgrel=${ZPMPACKAGEREL:-1}
-
-pkgroot=/
-
-# allocate an install id, perhaps hash package and timestamp
-# extract pre-scripts and run them
-# get list of paths to install
-# for each path, if directory, create and set mode
-# for each path, create leading directories
-# extract to something like /var/tmp/.hash, with low perms
-# only atomic if same filesystem, so use .installid.hash in the
-# install directory
-# set perms and such
-# move into place
-# after all the files, extract post scripts and run them
-
-# option for "multipackage" just to let the system know that's what you meant
-# option to take filenames from stdin
-# parse package, version, release from file if not given
-while getopts :f:v:r:d:a:u:l:p:b:P: opt; do
+warn() {
+       echo $* 1>&2
+}
+
+die() {
+       echo $* 1>&2
+       zpm log -i -a 'aborting install' -t "$pkgid" "$*"
+       exit 1
+}
+
+dryrun=0
+verbose=0
+runscripts=1
+runconfigure=1
+absorb=0
+overwrite=0
+syncopts=''
+
+# zpm-install [-SCn] [ -d localdb ] [ -f pkgfile ] [ -R installroot ] pkgstr ...
+while getopts f:d:R:nSCvAO opt; do
        case $opt in
-               R) pkgroot="$OPTARG" ;;
                f) pkgfile="$OPTARG" ;;
-               v) pkgver="$OPTARG" ;;
-               r) pkgrel="$OPTARG" ;;
-               d) description="$OPTARG" ;;
-               a) arch="$OPTARG" ;;
-               u) url="$OPTARG" ;;
-               l) licenses="$OPTARG" ;;
-               p) packager="$OPTARG" ;;
-               b) builddate="$OPTARG" ;;
-               P) prefix="$OPTARG" ;;
+               d) localdb="$OPTARG" ;;
+               R) rootdir="$OPTARG" ;;
+               S) runscripts=0 ;;
+               C) runconfigure=0 ;;
+               A) absorb=1; syncopts="${syncopts} -A" ;;
+               O) overwrite=1; syncopts="${syncopts} -O" ;;
+               n) dryrun=1 ;;
+               v) verbose=1 ;;
+               *) die "usage ..." ;;
        esac
 done
+shift $(( OPTIND - 1))
+
+pkgid=$1
+
+if [ -z "$pkgid" ]; then
+       die "must specify pkgid"
+fi
+
+eval "$(zpm parse -E $pkgid)"
 
-set -e
 if [ -z "$pkgfile" ]; then
-       pkgfile="$package-$pkgver-$pkgrel.zpm"
+       pkgfile=$ZPM_PACKAGE_FILE
 fi
 
-appid=$(sqlite3 $pkgfile 'pragma application_id;' | ( echo obase = 16; cat - ) | bc)
-if [ "$appid" != "5A504442" ]; then
-       echo $pkgfile does not appear to be a zpm package file
-       exit 1
+# cases R = full package id, F = specified package file
+
+# immediate error
+# -- 00 error, must specify something
+if [ -z "$release" ] && [ -z "$pkgfile" ]; then
+       die must specify package file or complete package id
 fi
 
-# check if package exists
-# run preinstall or preupgrade stage, in chroot
+# TODO look in package file
+# -F 01 error, wouldn't know which pkgid to create, could derive from file?
+if [ -z "$release" ]; then
+       # must have package file, or would have died above
+       pkgid=$(zpm findpkg -f $pkgfile $pkgid)
+       if [ -n "$pkgid" ]; then
+               eval "$(zpm parse -E $pkgid)"
+       fi
+fi
 
-# add package info and mark installing to local package database
-# each path: add to local db, extract, set mode/owner/mtime etc.
-# mark install done in local database
+if [ -z "$pkgid" ]; then
+       die "$0 can't figure out a package id"
+fi
 
-for path in $*; do
-       mtime=$(stat -c '%Y' $path)
-       uid=$(stat -c '%u' $path)
-       gid=$(stat -c '%g' $path)
-       username=$(stat -c '%U' $path)
-       groupname=$(stat -c '%G' $path)
-       mode=$(stat -c '%a' $path)
+# set file from pkgid
+# R- 10 set file from pkgid, create in file, error if no file
+if [ -z "$pkgfile" ]; then
+       pkgfile="$pkgid.zpm"
+fi
 
-       # strip off leading slashes
-       rpath=$(echo "$path" | sed -e 's|^/*||')
-       # and a leading ./
-       rpath=${rpath#./}
-       rpath=$(echo "$rpath" | sed -e 's|^/*||')
+# will now be one of these
+# RF 11 create package in file, error if file doesn't exist
+if [ ! -f "$pkgfile" ]; then
+       die $pkgfile does not exist
+fi
 
-       if [ -z "$rpath" ] || [ "$rpath" = '.' ]; then
+if [ "$idempotent" = 1 ]; then
+       idempotent='or ignore'
+fi
+
+package=$(zpm quote "$name")
+pkgver=$(zpm quote "$version")
+pkgrel=$(zpm quote "$release")
+
+if [ -n "$rootdir" ]; then
+       : rootdir=${rootdir%%/}
+fi
+
+if [ -z "$localdb" ]; then
+       localdb=${rootdir}/var/lib/zpm/local.db
+fi
+
+if [ ! -f "$localdb" ]; then
+       if [ -n "$rootdir" ] && [ ! -d $rootdir ]; then
+               mkdir $rootdir || die "can't create $rootdir: $!"
+       fi
+       for d in /var /var/lib /var/lib/zpm; do
+               test -d $rootdir/$d || mkdir $rootdir/$d || die "can't create $rootdir/$d/: $!"
+       done
+       zpm init "$localdb"
+       if [ $? -ne 0 ]; then
+               die "aborting install"
+       fi
+fi
+
+ZPMDB=$localdb
+export ZPMDB
+
+if [ -z "$ZPMDB" ]; then
+       die "no local db"
+else
+       #echo "localdb = $ZPMDB"
+       true
+fi
+
+zpm test -v "$ZPMDB" || die "$ZPMDB is not a zpm database"
+
+# check if we're installing something already
+var=$(zpm list -f $localdb -s installing | wc -l)
+if [ $var -gt 0 ]; then
+       zpm list -v -f $localdb -s installing 
+       die "already ($localdb) installing $var package(s)"
+fi
+# check if we're installing something already
+var=$(zpm list -f $localdb -s removing | wc -l)
+if [ $var -gt 0 ]; then
+       zpm list -v -f $localdb -s removing 
+       die "already ($localdb) removing $var package(s)"
+fi
+var=$(zpm list -f $localdb -s updating | wc -l)
+if [ $var -gt 0 ]; then
+       zpm list -v -f $localdb -s updating 
+       die "already ($localdb) updating $var package(s)"
+fi
+
+if [ -n "$rootdir" ]; then
+       ZPM_ROOT_DIR="$rootdir"
+       export ZPM_ROOT_DIR
+fi
+
+for pkgstr in "$@"; do
+       pkgid=$(zpm findpkg -f $pkgfile $pkgstr)
+       if [ $? -ne 0 ]; then
+               die "can't find package $pkgstr in $pkgfile"
+       fi
+
+       curstatus=$(zpm pkg $pkgid status)
+       if [ "$curstatus" = 'installed' ]; then
+               die "$pkgid already installed"
+       fi
+
+       eval $(zpm parse -E $pkgid)
+
+       #zpm list -v
+       current=$(zpm list -s installed "$package")
+       
+       if [ $runscripts -gt 0 ]; then
+               # TODO run pre-upgrade script if needed
+               # zpm runscript -p pre-upgrade $current $pkgid
+               zpm script -f $pkgfile -p pre-install $pkgid $current
+               if [ $? -ne 0 ]; then
+                       die "pre-install script for $pkgid failed"
+               fi
+       fi
+
+       # remove the package if it exists.  can't be in an installed
+       # state, would have bailed above.  So, if it exists, can only
+       # be 'upgraded'.  This should be fast, because we won't run
+       # a garbage collect, so any possible duplicate files between
+       # an upgraded or removed files, if they're there, won't need
+       # to be merged.
+
+       # only merge if localdb and pkgfile are different
+       if [ "$pkgfile" != "$ZPMDB" ]; then
+               zpm rmpackage $pkgid
+               zpm merge -f $pkgfile -s installing $pkgid
+               if [ $? -ne 0 ]; then
+                       die "merging $pkgid failed"
+               fi
+       else
+               zpm pkg $pkgid status=installing
+       fi
+
+       #zpm shell $ZPMDB 'select * from install_status' 1>&2
+       if [ $dryrun -gt 0 ]; then
+               #zpm list -v
+               #zpm shell $ZPMDB 'select * from install_status'
+               zpm syncfs $syncopts -nv -f $pkgfile
+               zpm pkg $pkgid status=dryrun
                continue
        fi
 
-       if [ ! -z "$prefix" ]; then
-               # trailing slashes on prefix
-               prefix=$(echo "$prefix" | sed -e 's|/*$||')
-               rpath="$prefix/$rpath"
+       if [ $verbose -gt 0 ]; then
+               syncopts="${syncopts} -v"
        fi
 
-       if [ -f "$path" ]; then
-
-               hash=$(./zpm-addfile $pkgfile $path)
-
-#if [ -z "$hash" ]; then continue; fi
-
-# TODO mtime, mode
-sqlite3 $pkgfile <<EOS
-PRAGMA foreign_keys = ON;
-insert or replace into packagefiles (package,version,release,path,mode,mtime,username,groupname,hash)
-values ('$package', '$pkgver', $pkgrel, '$rpath', '$mode',$mtime, '$username','$groupname','$hash')
-;
-EOS
-elif [ -d "$path" ]; then
-sqlite3 $pkgfile <<EOS
-PRAGMA foreign_keys = ON;
-insert or replace into packagefiles (package,version,release,path,mode,mtime,username,groupname)
-values ('$package', '$pkgver', $pkgrel, '$rpath', '$mode',$mtime, '$username','$groupname')
-;
-EOS
-elif [ -l "$path" ]; then
-       target=$(readlink $path)
-sqlite3 $pkgfile <<EOS
-PRAGMA foreign_keys = ON;
-insert or replace into packagefiles (package,version,release,path,mode,mtime,username,groupname,target)
-values ('$package', '$pkgver', $pkgrel, '$rpath', '$mode',$mtime, '$username','$groupname','$target')
-;
-EOS
-fi
-#printf "%s %s%s\n" $path $rpath ${target:+" -> $target"}
-printf "%s\n" $path
+       zpm syncfs $syncopts -f $pkgfile
+
+       if [ $? -ne 0 ]; then
+               zpm pkg $pkgid status=failed
+               die 'zpm-syncfs failed';
+       fi
+
+       if [ $runscripts -gt 0 ]; then
+               zpm script -f $pkgfile -p post-install $pkgid $current
+       fi
+
+       if [ -n "$current" ]; then
+               zpm pkg $pkgid status=installed :$current status=updated
+       else
+               zpm pkg $pkgid status=installed
+       fi
+
+       if [ $(id -u) -eq 0 ]; then
+               if [ ! -d $rootdir/etc ]; then
+                       warn "no etc directory in $rootdir, skipping ldconfig"
+               elif [ -f $rootdir/sbin/ldconfig ]; then
+                       $rootdir/sbin/ldconfig -r ${rootdir:-/}
+               elif [ -f /sbin/ldconfig ]; then
+                       /sbin/ldconfig -r ${rootdir:-/}
+               else
+                       true
+               fi
+       fi
+
+       # TODO skip configure if not on a terminal, regardless of settings
+       # TODO will need force option
+       if [ $runconfigure -gt 0 ]; then
+               zpm script -f $pkgfile -p configure $pkgid $current
+       else
+               true
+       fi
 done